// tstbcastDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tstbcast.h"
#include "tstbcastDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CTstbcastDlg dialog

CTstbcastDlg::CTstbcastDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTstbcastDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTstbcastDlg)
	m_log = _T("");
	//}}AFX_DATA_INIT
}

void CTstbcastDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTstbcastDlg)
	DDX_Text(pDX, IDC_EDIT1, m_log);
	//}}AFX_DATA_MAP
}

// Regiseter XGate windows mesg.
UINT NEAR XGATE_WM_BCAST_MESSAGE = RegisterWindowMessage(XGATE_BCAST_MESSAGE);

BEGIN_MESSAGE_MAP(CTstbcastDlg, CDialog)
	//{{AFX_MSG_MAP(CTstbcastDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP

	ON_REGISTERED_MESSAGE(XGATE_WM_BCAST_MESSAGE, XGateBCastMsg)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTstbcastDlg message handlers


BOOL CTstbcastDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Registration of xgate bcase mesg happens above in global variable.
	m_log += "Registering XGate broadcast mesg handler\r\n";

	// lock the port...
	Mutex = CreateMutex(0, false, XGATE_PORT_MUTEX_NAME);
	if (Mutex && WaitForSingleObject(Mutex, 60 * 1000) == WAIT_OBJECT_0) {
		m_log += "Locked mutex\r\n";
	} else {
		m_log += "hm... mutex lock failed. some thing is wrong\r\n";
	}


	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

LRESULT CTstbcastDlg::XGateBCastMsg(WPARAM wParam, LPARAM lParam)
{
	switch ( wParam ) {
	case XGATE_BCAST_REQ_RELEASE_PORT:
		m_log += "XGate wants the port so release it.\r\n";

		// comment this out to watch xgate fail to dial with a com port busy error.
		ReleaseMutex(Mutex);

		m_log += "Waiting for Xgate to finish\r\n";
		UpdateData(FALSE);
		break;

	case XGATE_BCAST_REQ_RELEASE_PORT_DONE:
		WaitForSingleObject(Mutex, INFINITE);
		m_log += "Reacquired the mutex\r\n";
		UpdateData(FALSE);
		break;
		
	}

	return 0;
}


void CTstbcastDlg::OnOK() 
{
	ReleaseMutex(Mutex);
	CloseHandle(Mutex);
	
	CDialog::OnOK();
}
